#
# Generated by SM2Gen version:0.9(20Jan2025) Chameleon version:4.5.4 On Python:3.12.3 at 2025-05-04 12:59:05 
#
#
# Routines to be edited by the developer to provide content and validation for parameters
# and provison of the control data for table(s)
#
use esmith::util;
use esmith::util::network;
use esmith::ConfigDB;
use esmith::HostsDB;
use esmith::AccountsDB;
use esmith::NetworksDB;
use esmith::DomainsDB;

use Encode::IMAPUTF7;
use Encode qw(decode);

use constant FALSE => 0;
use constant TRUE  => 1;

our $cdb  = esmith::ConfigDB->open();
our $adb = esmith::AccountsDB->open();
our $pdb = esmith::ConfigDB->open('processmail') or die "Could not open processmail DB\n";

our $PanelUser = $ENV{'REMOTE_USER'} ||'';
$PanelUser = $1 if ($PanelUser =~ /^([a-z][\.\-a-z0-9]*)$/);


#The most common ones
my $cdb; 
my $adb; 
my $pdb;
#my $ndb 
#my $hdb 
#my $ddb 

# Validation routines - parameters for each panel

	sub validate_TABLE {
		my $c = shift;
		my $ms_data = shift; #Data hash as parameter
		# Validation for each field 
		my $ret = "";
		
		if (! TRUE) #validate $c->param('account')
			{$ret .= 'Validation for account failed';}	
		if (! TRUE) #validate $c->param('username')
			{$ret .= 'Validation for username failed';}	
		if ($ret eq "") {$ret = 'ok';}
		return $ret;
	}

	sub validate_RULES {
		my $c = shift;
		my $ms_data = shift; #Data hash as parameter
		# Validation for each field 
		my $ret = "";
		
		if (! TRUE) #validate $c->param('basis')
			{$ret .= 'Validation for basis failed';}	
		if (! TRUE) #validate $c->param('criterion')
			{$ret .= 'Validation for criterion failed';}	
		if (! TRUE) #validate $c->param('basis2')
			{$ret .= 'Validation for basis2 failed';}	
		if (! TRUE) #validate $c->param('criterion2')
			{$ret .= 'Validation for criterion2 failed';}	
		if (! TRUE) #validate $c->param('action')
			{$ret .= 'Validation for action failed';}	
		if (! TRUE) #validate $c->param('deliver')
			{$ret .= 'Validation for deliver failed';}	
		if (! TRUE) #validate $c->param('folder')
			{$ret .= 'Validation for folder failed';}	
		if (! TRUE) #validate $c->param('copy')
			{$ret .= 'Validation for copy failed';}	
		if (! TRUE) #validate $c->param('action2')
			{$ret .= 'Validation for action2 failed';}	
		if (! TRUE) #validate $c->param('deliver2')
			{$ret .= 'Validation for deliver2 failed';}	
		if (! TRUE) #validate $c->param('key')
			{$ret .= 'Validation for key failed';}	
		if ($ret eq "") {$ret = 'ok';}
		return $ret;
	}

	sub validate_REMOVE {
		my $c = shift;
		my $ms_data = shift; #Data hash as parameter
		# Validation for each field 
		my $ret = "";
		
		if (! TRUE) #validate $c->param('RemoveRule')
			{$ret .= 'Validation for RemoveRule failed';}	
		if ($ret eq "") {$ret = 'ok';}
		return $ret;
	}


# Get singleton data for each panel

	sub get_data_for_panel_TABLE {
		# Return a hash with the fields required which will be loaded into the shared data 
		my $c = shift;
		my %ret = (
			'Data1'=>'Data for TABLE', #Example
			# fields from Inputs in TABLE $fields['TABLE']
			'account'=>$c->get_panel_user(),
			'username'=> $c->get_full_name(),
			
		);
		return %ret;
	}

sub get_data_for_panel_RULES {
    # Return a hash with the fields required which will be loaded into the shared data 
    my $c = shift;
    my $pdb = esmith::ConfigDB->open('processmail') or die "Could not open processmail DB\n";
    my $PanelUser = $c->get_panel_user();
    my $key = $c->param('Selected');

    # Get the rule object from the DB
    my $rule = $pdb->get($key);
    return () unless $rule;

    # Use the new routine to get rule data
    my $rule_info = get_rule_from_db($c, $rule);

    # Add/override any fields specific to the panel as needed
    my %ret = (
        %$rule_info,
    );

    return %ret;
}

	sub get_data_for_panel_REMOVE {
		# Return a hash with the fields required which will be loaded into the shared data 
		my $c = shift;
		my %ret = (
			'Data1'=>'Data for REMOVE', #Example
			# fields from Inputs in REMOVE $fields['REMOVE']
			'RemoveRule'=>'RemoveRule contents',
			
		);
		return %ret;
	}



# Get control data for table(s)

	# Define a constant hash for field name mapping
	use constant getAllRules_FIELD_MAPPING => (
		'MatchAgainst' => 'basis',
		'TheRule' => 'criterion',
		'c2ndMatch' => 'basis2',
		'c2ndRule' => 'criterion2',
		'Action' => 'action',
		'Destination' => 'deliver',
		'Copy' => 'copy',
		'Destination2' => 'deliver2',
		'Serial Number' => 'key',
		'Modify' => 'Modify',
		'Remove' => 'Remove'
		#'target_field2' => 'source_field2',
		# Add more mappings as needed
	);
	
sub actual_getAllRules {
    my $c = shift;
    my @data;

    # Open the required databases
    my $cdb  = esmith::ConfigDB->open();
    my $adb  = esmith::AccountsDB->open();
    my $pdb  = esmith::ConfigDB->open('processmail') or die "Could not open processmail DB\n";
    my $PanelUser = $c->get_panel_user();

    my @rules = $pdb->get_all_by_prop(type => "$PanelUser");
    return $c->l("NO_RULES") if (@rules == 0);

    foreach my $rule (@rules) {
        # Get the rule info as a hashref using the new routine
        my $rule_info = get_rule_from_db($c, $rule);
        # except restore the folder into deliver
        if ($rule_info->{action} eq 'sort'){
			$rule_info->{deliver} = $rule_info->{folder};
		}
        # Add any extra fields needed for the UI
        $rule_info->{Modify} = "<a href=mailsortingd?trt=RULES&account=$PanelUser&Selected=$rule_info->{key}>".$c->l('MODIFY')."</a>";
        $rule_info->{Remove} = "<a href=mailsortingd?trt=REMOVE&account=$PanelUser&Selected=$rule_info->{key}>".$c->l('REMOVE')."</a>";
        # If you want to keep these for compatibility (though they seem odd)
        $rule_info->{a} = $a if defined $a;
        $rule_info->{b} = $b if defined $b;
        $rule_info->{c} = $c;

        push @data, $rule_info;
    }
    return @data;
}

sub get_getAllRules {
    # Return an array of hashes of the contents for each row and column for getAllRules
	my $c = shift;
	

    my @source_records = $c->actual_getAllRules();
    my @transformed_records;
    my %Field_Mapping = getAllRules_FIELD_MAPPING();
    # Iterate over each record in the source array
    for my $source_record (@source_records) {
        my %transformed_record;
        # Iterate over each key-value pair in the $Field_Mapping constant
        while (my ($target, $source) = each %Field_Mapping) {
            # Check if the source field exists in the source record
            if (exists $source_record->{$source}) {
                # Assign the source field value to the target field in the transformed record
                $transformed_record{$target} = $source_record->{$source};
            }
        }
        # Add transformed record to the array if it's not empty
        push @transformed_records, \%transformed_record if %transformed_record;
    }
    return \@transformed_records;
}



# Return hash with values from row in which link clicked on table

	sub get_selected_TABLE {
		my $c = shift;
		my $selected = shift; #Parameter is name of selected row.
		my $is_new_record = shift; #Indicates new record required (defaults)
		my %ret = {};
		return %ret;
	}

	sub get_selected_RULES {
		my $c = shift;
		my $selected = shift; #Parameter is name of selected row.
		my $is_new_record = shift; #Indicates new record required (defaults)
		my %ret = {};
		return %ret;
	}

	sub get_selected_REMOVE {
		my $c = shift;
		my $selected = shift; #Parameter is name of selected row.
		my $is_new_record = shift; #Indicates new record required (defaults)
		my %ret = {};
		return %ret;
	}


#after sucessful modify or create or whatever and submit then perfom (if the params validate)

	sub perform_TABLE {
		my $c = shift;
		my $ms_data = shift; #Data hash as parameter
		my $ret = "";
		my $db = $cdb; #maybe one of the others
		my $dbkey = 'ChangeThis';
		# To make it write to DB as comment, delete this (regex) string in each if statement "TRUE\) \#copy or perform with value: .* e.g."
		
		if (! TRUE) #copy or perform with value: account e.g. $db->set_prop($dbkey,'account',$c->param('account'),type=>'service'))
			{$ret .= 'Perform/save failed for account';}
		if (! TRUE) #copy or perform with value: username e.g. $db->set_prop($dbkey,'username',$c->param('username'),type=>'service'))
			{$ret .= 'Perform/save failed for username';}
		if ($ret eq "") {$ret = 'ok';}
		return $ret;
	}

	sub perform_RULES {
		my $c = shift;
		my $ms_data = shift; #Data hash as parameter

		my $ret = $c->save_rule();

		#my $db = $cdb; #maybe one of the others
		#my $dbkey = 'ChangeThis';
		## To make it write to DB as comment, delete this (regex) string in each if statement "TRUE\) \#copy or perform with value: .* e.g."
		#if (! TRUE) #copy or perform with value: basis e.g. $db->set_prop($dbkey,'basis',$c->param('basis'),type=>'service'))
			#{$ret .= 'Perform/save failed for basis';}
		#if (! TRUE) #copy or perform with value: criterion e.g. $db->set_prop($dbkey,'criterion',$c->param('criterion'),type=>'service'))
			#{$ret .= 'Perform/save failed for criterion';}
		#if (! TRUE) #copy or perform with value: basis2 e.g. $db->set_prop($dbkey,'basis2',$c->param('basis2'),type=>'service'))
			#{$ret .= 'Perform/save failed for basis2';}
		#if (! TRUE) #copy or perform with value: criterion2 e.g. $db->set_prop($dbkey,'criterion2',$c->param('criterion2'),type=>'service'))
			#{$ret .= 'Perform/save failed for criterion2';}
		#if (! TRUE) #copy or perform with value: action e.g. $db->set_prop($dbkey,'action',$c->param('action'),type=>'service'))
			#{$ret .= 'Perform/save failed for action';}
		#if (! TRUE) #copy or perform with value: deliver e.g. $db->set_prop($dbkey,'deliver',$c->param('deliver'),type=>'service'))
			#{$ret .= 'Perform/save failed for deliver';}
		#if (! TRUE) #copy or perform with value: folder e.g. $db->set_prop($dbkey,'folder',$c->param('folder'),type=>'service'))
			#{$ret .= 'Perform/save failed for folder';}
		#if (! TRUE) #copy or perform with value: copy e.g. $db->set_prop($dbkey,'copy',$c->param('copy'),type=>'service'))
			#{$ret .= 'Perform/save failed for copy';}
		#if (! TRUE) #copy or perform with value: action2 e.g. $db->set_prop($dbkey,'action2',$c->param('action2'),type=>'service'))
			#{$ret .= 'Perform/save failed for action2';}
		#if (! TRUE) #copy or perform with value: deliver2 e.g. $db->set_prop($dbkey,'deliver2',$c->param('deliver2'),type=>'service'))
			#{$ret .= 'Perform/save failed for deliver2';}
		#if (! TRUE) #copy or perform with value: key e.g. $db->set_prop($dbkey,'key',$c->param('key'),type=>'service'))
			#{$ret .= 'Perform/save failed for key';}
		#if ($ret eq "") {$ret = 'ok';}
		return $ret;
	}

	sub perform_REMOVE {
		my $c = shift;
		my $ms_data = shift; #Data hash as parameter
		my $ret = "";
		my $db = $cdb; #maybe one of the others
		my $dbkey = 'ChangeThis';
		# To make it write to DB as comment, delete this (regex) string in each if statement "TRUE\) \#copy or perform with value: .* e.g."
		
		if (! TRUE) #copy or perform with value: RemoveRule e.g. $db->set_prop($dbkey,'RemoveRule',$c->param('RemoveRule'),type=>'service'))
			{$ret .= 'Perform/save failed for RemoveRule';}
		if ($ret eq "") {$ret = 'ok';}
		return $ret;
	}


sub create_link{
	# WIP
	my ($c,$route, $panel, $index) = @_;
	my $link = "$route?trt=$panel&Selected=$index";
	return $link;
}

sub get_panel_user
{
	my $c = shift;
    return $c->session->{username};
}

sub get_full_name{
	my $c = shift;
	my $adb = esmith::AccountsDB->open();
	my $PanelUser = $c->get_panel_user();
    return  $adb->get_prop($PanelUser, "FirstName") . " " .
            $adb->get_prop($PanelUser, "LastName");
}

sub GetDisplayName {
    my ($s) = @_;
    $s =~ s/(.*)//;   # untaint the input
    my $decoded = decode('IMAP-UTF-7', $1);
    return $decoded;
}

sub get_Folders {
    my $c = shift;
    my $folders_hashref = $c->listfolders();
    # Convert hashref to arrayref of arrayrefs for Mojolicious select
    my @options = map { [ $_, $folders_hashref->{$_} ] } sort keys %$folders_hashref;
    return \@options;
}

sub listfolders
{
	my $c = shift;
	use File::Find::Rule;
	my $PanelUser = $c->get_panel_user();
	my $root="/home/e-smith/files/users/$PanelUser/Maildir";
	$root="/home/e-smith/Maildir"  if  "$PanelUser" eq "admin" ;
	my @dirs = File::Find::Rule->new
	    ->extras({ untaint => 1 , untaint_pattern => qr|^([-+@\w&. /]+)$| })
	    ->directory
	    ->maxdepth(1)
	    ->in($root);
	my %out_dir;
	$out_dir{"INBOX"} .= "INBOX";
	$out_dir{""} .= "";
	for (sort @dirs) {
	       s/$root\/?\.?//;
	       my @exclu =("cur", "tmp", "new" , "INBOX" );
	       next if $_  ~~ @exclu;
	       $out_dir{$_} .= GetDisplayName(join('/',split('\.', $_)));
       	}
	return \%out_dir;
}

sub get_rule_from_db{
	$c = shift;
	$rule = shift;
	my $key        = $rule->key;
	my $basis      = $rule->prop("basis")     || '';
	my $basis2     = $rule->prop("basis2")    || '';
	my $deliver    = $rule->prop("deliver")   || '';
	my $deliver2   = $rule->prop("deliver2")  || '';
	my $action     = $rule->prop("action")    || '';
	my $action2    = $rule->prop("action2")   || '';
	my $folder    = ("$action" eq "sort" )? $deliver  : '';
	$folder = "INBOX" if "$folder" eq "" && "$action" eq "sort";
	my $copy       = $rule->prop("copy")      || '';
	my $oldpmRule  = '';
	my $criterion =  $rule->prop("criterion")   || '';
	my $criterion2 =  $rule->prop("criterion2")   || '';
	my $deliver     = '' if "$action" eq "sort";

	for ($basis, $basis2)
	{
	 if ($_ eq '<')
	 { $_ =  'sizelt'; }
	 elsif ($_ eq '>')
	 { $_ =  'sizegt'; }
	}
	
	my $b1    = $c->l($basis);
	my $b2    = $c->l($basis2);
	
	my $copyto     = $rule->prop("deliver2")  || '';# useless
	if (($copy eq 'yes') && ($action2 eq 'inbox'))
	{ $deliver2 = "";  $copyto = 'inbox'; } # copyto is useless

	$deliver = GetDisplayName($deliver);
	$deliver2 = GetDisplayName($deliver2);
    my $result = {
        key        => $key,
        basis      => $basis,
        basis2     => $basis2,
        deliver    => $deliver,
        deliver2   => $deliver2,
        action     => $action,
        action2    => $action2,
        folder     => $folder,
        copy       => $copy,
        b1         => $b1,
        b2         => $b2,
        copyto     => $copyto,
        criterion  => $criterion,
        criterion2  => $criterion2,
        oldkey     => $key
    };
}

sub save_rule
{
    my $c = shift;
    my $pdb  = esmith::ConfigDB->open('processmail') or die "Could not open processmail DB\n";
    my $PanelUser = $c->get_panel_user();

    my $rule = $c->param ('key')  || '';
    #my $q = 
    if (($rule eq '') || ($rule eq 'new'))
    {
      my $random = int(rand(999999));
      $rule = $PanelUser.$random;
      $pdb->new_record($rule, { type => "$PanelUser" });
    }
    my %filtered;
    $filtered{criterion}      .= $c->param ('criterion')     || '';
    $filtered{criterion2}    .= $c->param ('criterion2')    || '';
    $filtered{basis}      .= $c->param ('basis')     || '';
    $filtered{basis2}    .= $c->param ('basis2')    || '';
    $filtered{action}    .= $c->param ('action')     || '';
    $filtered{action2}   .= $c->param ('action2')    || '';
    $filtered{deliver}   .= $c->param ('deliver')    || '';
    $filtered{deliver2}   .= $c->param ('deliver2')   || '';
    $filtered{folder}    .= $c->param ('folder')    || '';
    $filtered{copy}       .= $c->param ('copy')       || '';
    $filtered{oldkey}     .= $c->param ('oldkey')     || '';

    if ($filtered{basis} eq 'sizelt')  { $filtered{basis}  = '<'; }
    if ($filtered{basis} eq 'sizegt')  { $filtered{basis}  = '>'; }
    if ($filtered{basis2} eq 'sizelt') { $filtered{basis2} = '<'; }
    if ($filtered{basis2} eq 'sizegt') { $filtered{basis2} = '>'; }

    # we use the folder drop box selection if asked to sort
    $filtered{folder} = "" if $filtered{folder} eq "INBOX";
    $filtered{deliver} = $filtered{folder} if $filtered{action} eq "sort";

    if ($filtered{copy} eq 'no')       { $filtered{deliver2} = '';  $filtered{action2} = ''; }
    if ($filtered{copy} eq 'yes' &&  $filtered{action2} eq 'inbox')       { $filtered{deliver2} = ''; }

    # keys are different but rule at least has part of users name so is likely changed
    if (($filtered{oldkey} ne $rule) && ($filtered{oldkey} =~ /$PanelUser/))
    {
        $pdb->new_record($rule, { type => "$PanelUser" });

        my $rec = $pdb->get($filtered{oldkey});
        $rec->delete;
    }

    foreach ("criterion","criterion2","action","action2","copy","basis","basis2","deliver","deliver2" )
    { $pdb->set_prop($rule, "$_", $filtered{$_}); }

    unless ( system ("/sbin/e-smith/signal-event mailsorting-conf $PanelUser") == 0 )
    { return 'ERROR_UPDATING'; }

    return "ok";
}

#
# This are for the future enhanced version.
#
sub describe_procmail_rule {
    my ($rule) = @_;
    my @lines = grep { /\S/ } map { s/^\s+|\s+$//gr } split /\n/, $rule;
    my ($header, @conditions, $action);
    $header = shift @lines if $lines[0] =~ /^:0/;
    while (@lines && $lines[0] =~ /^\*/) {
        push @conditions, shift @lines;
    }
    $action = join(' ', @lines);
    my $desc = "";
    if ($header) {
        my $flags = $header; $flags =~ s/^:0//; $flags =~ s/:$//; $flags =~ s/\s+//g;
        $desc .= "Recipe flags: " . ($flags ? $flags : "none") . ". ";
    }
    if (@conditions) {
        $desc .= "Matches if ";
        my @cond_descs;
        foreach my $cond (@conditions) {
            $cond =~ s/^\*\s*//;
            if ($cond =~ /^\^(.*?):\s*(.*)/) {
                push @cond_descs, "the header '$1' contains '$2'";
            } elsif ($cond =~ /^\//) {
                push @cond_descs, "the body matches regex '$cond'";
            } else {
                push @cond_descs, "the message matches '$cond'";
            }
        }
        $desc .= join(" AND ", @cond_descs) . ". ";
    } else {
        $desc .= "Matches all messages. ";
    }
    if ($action) {
        if ($action =~ m{^/}) {
            $desc .= "Delivers to file or mailbox '$action'.";
        } elsif ($action =~ /^[A-Za-z0-9_\-]+$/) {
            $desc .= "Delivers to folder '$action'.";
        } elsif ($action =~ /^\!/) {
            $desc .= "Forwards to address '" . (split ' ', $action, 2)[1] . "'.";
        } elsif ($action =~ /^\|/) {
            $desc .= "Pipes message to command '" . (substr $action, 1) . "'.";
        } else {
            $desc .= "Performs action: '$action'.";
        }
    } else {
        $desc .= "No action specified.";
    }
    return $desc;
}

sub construct_procmail_rule {
    my ($entry) = @_;

    # Start the recipe header
    my $flags = '';
    $flags .= 'c' if ($entry->{copy} && $entry->{copy} eq 'yes');
    my $header = ":0$flags:";

    # Build conditions
    my @conditions;
    if ($entry->{basis} && $entry->{criterion}) {
        my $cond = ($entry->{basis} eq 'Subject')
            ? "^Subject:.*$entry->{criterion}"
            : ($entry->{basis} eq 'headers')
                ? $entry->{criterion}
                : "^$entry->{basis}:.*$entry->{criterion}";
        push @conditions, "* $cond";
    }
    if ($entry->{basis2} && $entry->{criterion2}) {
        my $cond2 = ($entry->{basis2} eq 'Subject')
            ? "^Subject:.*$entry->{criterion2}"
            : ($entry->{basis2} eq 'headers')
                ? $entry->{criterion2}
                : "^$entry->{basis2}:.*$entry->{criterion2}";
        push @conditions, "* $cond2";
    }

    # Build action
    my $action = '';
    if ($entry->{action} && $entry->{action} eq 'delete') {
        $action = "/dev/null";
    } elsif ($entry->{deliver}) {
        $action = $entry->{deliver};
    } else {
        $action = "INBOX"; # Default action
    }

    # Assemble the recipe
    my $rule = $header . "\n";
    $rule .= join("\n", @conditions) . "\n" if @conditions;
    $rule .= "$action\n";
    return $rule;
}

sub get_esmith_db_property {
	# as a hashref
    my ($db, $key, $prop) = @_;
    my $record = $db->get($key) or return undef;
    my $value = $record->prop($prop);
    return $value;
}





1;